/***************************************************************************
                          start.cpp  -  description
                             -------------------
    begin                : Tue Feb 27 2001
    copyright            : (C) 2001 by kulich
    email                : xrotek@fi.muni.cz
 ***************************************************************************/
#include <stdlib.h>
#include "minimax.h"
#include "Interface.h"
#include <math.h>
#include <time.h>

extern const int WIDTH, HEIGHT;
extern int PlayerRedCount, PlayerBlueCount;

bool first_turn=true;
Board PlayBoard(WIDTH,HEIGHT);

int MakeMove() {
	
	cout << "Premyslim.... ";
	int best_move_attack=0;
	int best_move_defend=0;
	int best_move=0;
	int best_value_attack;
	int best_value_defend;
	int max_depth = MAXDEPTH;

	MinMax algo;
	best_move_defend=algo.ChooseNextMove(1,max_depth, best_value_defend,-MAXINT, MAXINT);
	cout<<"RED : "<<PlayerRedCount<<" , "<<"BLUE : "<<PlayerBlueCount<< endl;
	cout<<"------"<<endl;
	MinMax algo1;
	max_depth = (max_depth-1)>0?max_depth-1:1;
	best_move_attack=algo1.ChooseNextMove(0, max_depth, best_value_attack, -MAXINT, MAXINT);
	cout<<"RED : "<<PlayerRedCount<<" , "<<"BLUE : "<<PlayerBlueCount<< endl;

	cout<<"defend : "<<best_value_defend<<"    attack : "<<best_value_attack<<endl;
	if (abs(best_value_attack)+1>=best_value_defend&&!first_turn) {
		cout << "Utocim"<<endl;
		best_move=best_move_attack;
	}
	else {
		cout << "Branim se"<<endl;
		best_move=best_move_defend;
	};

	first_turn=false;
	cout << "Tah pocitace je " << best_move << endl;
	MinMax minimax;
	Board returned_board(WIDTH,HEIGHT);
	if (minimax.DetectCycles(0,best_move, returned_board)) {
		PlayBoard[best_move]=-1;
		returned_board[best_move]=10;
		int blue_count=0;
		List<PointToReturn> * list_to_return;
		list_to_return=minimax.CloseCyclesOnBoard(0,returned_board,blue_count);
		for (int i=0; i<list_to_return->GetCard(); i++) {
			PlayerBlueCount--;
			PlayBoard[(*list_to_return)[i].GetPosition()]=-1;
		};
		delete(list_to_return);	
	}
	else PlayBoard[best_move]=-1;

	if (PlayerRedCount-PlayerBlueCount + 1== WIDTH*HEIGHT) {
		cout << endl << "The game is over....." << endl;
		return 0;
	}
	return best_move;

}

int main(int * argc, char ** argv) {

	InitWindow(argc, argv);

	return(0);

};



